﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace ConsoleApplication5
{
    sealed class IO
    {
        private string[] delimiters = { "; ", ": " };

        private string absolutePath;

        public void LoadFile(string absolutePath, ref TypeOfRoad[] typesOfRoad, ref Town[] towns, ref Landscape[] landcapes, ref Condition[] conditions, ref int MaxFinance)
        {
            this.absolutePath = absolutePath;
            // Načtení textu ze souboru
            string text = File.ReadAllText(absolutePath);
            // Rozčlenění na jednotlivé sekce
            //string[] parts = Regex.Split(text, @"(\r\n){2}");
            string[] parts = text.Split(new[] { "\r\n\r\n" }, StringSplitOptions.None);

            // Načtení měst
            List<string[]> list = SplitObjects(parts[0]);
            towns = new Town[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                towns[i] = new Town(float.Parse(list[i][1], CultureInfo.InvariantCulture),
                                    float.Parse(list[i][2], CultureInfo.InvariantCulture), i);
            }

            // Načtení silnic
            list = SplitObjects(parts[1]);
            typesOfRoad = new TypeOfRoad[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                typesOfRoad[i] = new TypeOfRoad(float.Parse(list[i][1], CultureInfo.InvariantCulture),
                                                float.Parse(list[i][2], CultureInfo.InvariantCulture), i);
            }

            // Načtení použitelných financí
            list = SplitObjects(parts[2]);
            MaxFinance = int.Parse(list[0][0], CultureInfo.InvariantCulture);

            // Načtení podmínek
            list = SplitObjects(parts[3]);
            conditions = new Condition[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                conditions[i] = new Condition(int.Parse(list[i][0], CultureInfo.InvariantCulture),
                                              int.Parse(list[i][1], CultureInfo.InvariantCulture),
                                              float.Parse(list[i][2], CultureInfo.InvariantCulture));
            }

            // Načtení krajin
            list = SplitObjects(parts[4]);
            landcapes = new Landscape[list.Count];
            for (int i = 0; i < list.Count; i++)
            {
                landcapes[i] = new Landscape(float.Parse(list[i][0], CultureInfo.InvariantCulture),
                                             float.Parse(list[i][1], CultureInfo.InvariantCulture),
                                             float.Parse(list[i][2], CultureInfo.InvariantCulture),
                                             float.Parse(list[i][3], CultureInfo.InvariantCulture),
                                             float.Parse(list[i][4], CultureInfo.InvariantCulture));
            }
        }

        // Splitování z jednotlivých částí (např. MESTA) na jednotlivé řádky a položky
        private List<string[]> SplitObjects(string part)
        {
            List<string[]> list = new List<string[]>();

            string[] rows = part.Split('\n');
            for (int i = 1; i < rows.Length; i++)
            {
                string[] items = rows[i].Split(delimiters, StringSplitOptions.None);
                list.Add(items);
            }
            return list;
        }

        public void SaveFile(List<Road> roads)
        {
            string text = "";

            foreach (Road road in roads)
            {
               text += "\n"+road.Town1.OriginalIndex+";"+road.Town2.OriginalIndex+";"+road.typeOfRoad.OriginalIndex+"\n";
            }

            File.WriteAllText(absolutePath, text);

            Console.WriteLine("Text je uložen ve stejném soboru, jako byl i načten.");
        }
    }
}
