﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace caRoads
{
    public class RoadType
    {
        public string Name { get; set; }

        private double price;
        public double Price
        {
            get { return price; }
            set
            {
                if (value < 0)
                    throw new ArgumentOutOfRangeException("RoadType.Price");
                price = value;
            }
        }

        private double speed;
        public double Speed
        {
            get { return speed; }
            set
            {
                if (value <= 0)
                    throw new ArgumentOutOfRangeException("RoadType.Speed");
                speed = value;
            }
        }

        public RoadType(string name, double price, double speed)
        {
            this.Name = name;
            this.Price = price;
            this.Speed = speed;
        }

        public static RoadType Parse(string text)
        {
            int separatorPosition = text.IndexOf(':');
            string name = text.Substring(0, separatorPosition).Trim();
            if (separatorPosition < 1)
                throw new FormatException("Vstupni parametr nema spravny format.");
            string[] values = text.Substring(separatorPosition + 1).Split(Globals.separator, StringSplitOptions.RemoveEmptyEntries);
            double price, speed;
            if (values.Length != 2 || !double.TryParse(values[0].Trim(), out price) || !double.TryParse(values[1].Trim(), out speed))
                throw new FormatException("Vstupni parametr nema spravny format.");
            return new RoadType(name, price, speed);
        }


    }
}
