﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace caRoads
{
    public class Town
    {
        public Location Location { get; private set; }
        public string Name { get; set; }

        
        public Town(string name, Location location)
        {
            this.Location = location;
            this.Name = name;
        }

        public Town(string name, double x, double y)
            :this(name, new Location(x, y))
        {}

        public static Town Parse(string text)
        {
            int separatorPosition = text.IndexOf(':');
            string name = text.Substring(0, separatorPosition).Trim();
            if (separatorPosition < 1)
                throw new FormatException("Vstupni parametr nema spravny format.");
            string[] values = text.Substring(separatorPosition+1).Split(Globals.separator, StringSplitOptions.RemoveEmptyEntries);
            double x, y;
            if (values.Length != 2 || !double.TryParse(values[0].Trim(), out x) || !double.TryParse(values[1].Trim(), out y))
                throw new FormatException("Vstupni parametr nema spravny format.");
            return new Town(name, x, y);
        }

        public override string ToString()
        {
            return string.Format("{0} [{1};{2}]", Name, Location.X, Location.Y);
        }

        public override bool Equals(object obj)
        {
            if (!(obj is Town))
                return false;
            return ((Town)obj).Name == this.Name;
        }
    }
}
