<?php
class Parser{
	private $source;

	public function Parser($input){
		$this->source = explode("\n\n",$input);
	}
	
	
	public function getCities(){
		foreach($this->source as $piece){ 	// projedu všechny čísti zadání
			$pattern = '/^MESTA/m';   		// pokud se jedná o zadání měst
			if(preg_match($pattern, $piece)){	//cyklus skrze řádky části o městech
				$cityarray = explode("\n",$piece);	//rozdělení na řádky
					for($x=0;$x<=count($cityarray);$x++){	
						if($cityarray[$x] == "" || preg_match($pattern, $cityarray[$x]))	//zjištění validity řádku
							unset($cityarray[$x]); // smazání neplatných řádků
					}
				
				$cities = array();	//pole měst
				foreach($cityarray as $city){// projedu všechna města a převedu je na objekty
					array_push($cities,new City($city));
				}
				return $cities;//hotovo, vracím pole měst;
			}
		}
	}
	
	
	
	public function getRoads(){
		foreach($this->source as $piece){ 	// projedu všechny čísti zadání
			$pattern = '/^SILNICE/m';   		// pokud se jedná o definice cest
			if(preg_match($pattern, $piece)){	//cyklus skrze řádky části o cestách
				$roadarray = explode("\n",$piece);	//rozdělení na řádky
					for($x=0;$x<=count($roadarray);$x++){	
						if($roadarray[$x] == "" || preg_match($pattern, $roadarray[$x]))	//zjištění validity řádku
							unset($roadarray[$x]); // smazání neplatných řádků
					}
				
				$roads = array();	//pole silnic
				foreach($roadarray as $road){// projedu všechny typy silnic a převedu je na objekty
					array_push($roads,new RoadType($road));
				}
				return $roads;//hotovo, vracím pole silnic;
			}
		}
	}
	
	public function getMoney(){
		foreach($this->source as $piece){ 	// projedu všechny čísti zadání
			$pattern = '/^FINANCE/m';   		// pokud se jedná o hodnotu financi
			if(preg_match($pattern, $piece)){	//cyklus skrze řádky části o financích
				return floatval(filter_var($piece, FILTER_SANITIZE_NUMBER_INT));
			}
		}
	}
	
	public function getRules(){
		foreach($this->source as $piece){ 	// projedu všechny čísti zadání
			$pattern = '/^PODMINKY/m';   		// pokud se jedná o podminky
			if(preg_match($pattern, $piece)){	//cyklus skrze řádky části o podminkach
				$rulesarray = explode("\n",$piece);	//rozdělení na řádky
					for($x=0;$x<=count($rulesarray);$x++){	
						if($rulesarray[$x] == "" || preg_match($pattern, $rulesarray[$x]))	//zjištění validity řádku
							unset($rulesarray[$x]); // smazání neplatných řádků
					}
				
				$rules = array();	//pole podminek
				foreach($rulesarray as $rule){// projedu všechny podminky a prevedu je na objekty
					array_push($rules,new Rule($rule));
				}
				return $rules;//hotovo, vracím pole podminek;
			}
		}
	}
	
	public function getRegions(){
		foreach($this->source as $piece){ 	// projedu všechny čísti zadání
			$pattern = '/^KRAJINA/m';   		// pokud se jedná o definice krajin
			if(preg_match($pattern, $piece)){	//cyklus skrze řádky části o krajinách
				$landscapearray = explode("\n",$piece);	//rozdělení na řádky
					for($x=0;$x<=count($landscapearray);$x++){	
						if($landscapearray[$x] == "" || preg_match($pattern, $landscapearray[$x]))	//zjištění validity řádku
							unset($landscapearray[$x]); // smazání neplatných řádků
					}
				$regions = array();	//pole podminek
				foreach($landscapearray as $landscape){// projedu všechny regiony a prevedu je na objekty
					array_push($regions,new Region($landscape));
				}
				return $regions;//hotovo, vracím pole regionu;
			}
		}
	}
}

?>
