<?php
class Solver{
	private $mesta;
	private $typySilnic;
	private $hotovost;
	private $podminky;
	private $regiony;

	public $kostra = array();

	public function output(){
		$out = "";
		foreach($this->kostra as $road){
			$out .= $road->from->getID() . ";" . $road->to->getID() . ";" . $road->type->getID() . "\n";
		}
		return $out;
	}

	public function Solver($mesta,$typySilnic,$hotovost,$podminky,$regiony){
		$this->mesta =$mesta;
		$this->typySilnic=$typySilnic;
		$this->hotovost=$hotovost;
		$this->podminky=$podminky;
		$this->regiony=$regiony;
		
		usort($this->typySilnic, function($a, $b){
		    return $a->getCena() > $b->getCena();
		});
		
		$this->solve();
	}

	public function solve(){
		$pocet = count($this->mesta);
		$allRoads = array();
		
		for($x=0;$x<$pocet;$x++){
			for($y=0;$y<$pocet;$y++){
				if($x != $y){
					$cesta = new Road($this->mesta[$x],$this->mesta[$y],$this->regiony,$this->typySilnic[0]);
					
					$eq = false;
					foreach($this->kostra as $ces){
						if($cesta->equality($ces))
							$eq = true;
					}
					
					if(!$eq){
						array_push($allRoads,$cesta);
					}
				}
			}
		}
		
		usort($allRoads, function($a, $b){
		    return $a->getTime() > $b->getTime();
		});
		
		foreach($allRoads as $road){
			array_push($this->kostra,$road);
			$this->uncycle();
		}
				

	}

	private function uncycle(){
		$checker = new CycleDetector($this->kostra);

		if($checker->isCyclic()){
			unset($this->kostra[count($this->kostra)-1]);
			$this->kostra = array_values($this->kostra);
		}
	}


}

?>
