<?php
include "./Parser.class.php";
include "./Point.class.php";
include "./City.class.php";
include "./RoadType.class.php";
include "./Rule.class.php";
include "./Region.class.php";
include "./Solver.class.php";
include "./Road.class.php";
include "./CycleDetector.class.php";

$zadani= file_get_contents('./in_out/input.txt');

$parser = new Parser($zadani);

$mesta = $parser->getCities();
$typySilnic = $parser->getRoads();
$hotovost = $parser->getMoney();
$podminky = $parser->getRules();
$regiony = $parser->getRegions();


$solver = new Solver($mesta,$typySilnic,$hotovost,$podminky,$regiony);
$kostra = $solver->kostra;


$file = './in_out/output.txt';
$data = $solver->output();
file_put_contents($file, $data);































//-----------------------------------------------------------
//-----------------------------------------------------------
//-----------------------------------------------------------
//-----------------------------------------------------------

///		VIZUALIZACE

//-----------------------------------------------------------
//-----------------------------------------------------------
//-----------------------------------------------------------
//-----------------------------------------------------------
$MERITKO = 20;
$sizeX = 0;
$sizeY = 0; 
foreach($mesta as $city){
	if($city->getPos()->x > $sizeX)
		$sizeX = $city->getPos()->x;
	if($city->getPos()->y > $sizeY)
		$sizeY = $city->getPos()->y;
}
$img_width = (($sizeX * $MERITKO) + (2*$MERITKO));   	// přičítám 2*měřítko , kvůli okrajům
$img_height = (($sizeY * $MERITKO) + (2*$MERITKO));	// přičítám 2*měřítko , kvůli okrajům

$img = imagecreate( $img_width, $img_height);
$background = imagecolorallocate( $img, 200, 200, 200 );
$cityColor = imagecolorallocate( $img, 0, 0, 200 );
$landColor = imagecolorallocate( $img, 0, 150, 0 );
$landDescColor = imagecolorallocate( $img, 150, 255, 150 );

$landColorX = imagecolorallocate( $img, 150, 0, 0 );
$landDescColorX = imagecolorallocate( $img, 255, 150, 150 );

$roadColor = imagecolorallocate( $img, 50, 50, 50 );

//vykreslení regionů
foreach($regiony as $region){
	imagefilledrectangle (
			$img , 
			$region->getPos()->x*$MERITKO + $MERITKO , 
			$region->getPos()->y*$MERITKO + $MERITKO , 
			($region->getPos()->x + $region->getSize()->x)*$MERITKO + $MERITKO , 
			($region->getPos()->y + $region->getSize()->y)*$MERITKO + $MERITKO , 
			($region->getSpeed() < 1 ? $landColor : $landColorX)
	);
	imagestring( $img, 
			4, 
			($region->getPos()->x + ($region->getSize()->x/3))*$MERITKO + $MERITKO ,
			($region->getPos()->y + ($region->getSize()->y/3))*$MERITKO + $MERITKO ,  
			$region->getSpeed(), 
			($region->getSpeed() < 1 ? $landDescColor : $landDescColorX)
	);
}

//vykreslení měst
foreach($mesta as $city){
	imagefilledarc($img, $city->getPos()->x*$MERITKO + $MERITKO, $city->getPos()->y*$MERITKO + $MERITKO, 20, 20,  0, 360,$cityColor,IMG_ARC_PIE);
	imagestring( $img, 5, $city->getPos()->x*$MERITKO + $MERITKO-20, $city->getPos()->y*$MERITKO + $MERITKO-20,  $city->getID(), $cityColor );
}

//vykreslení silnic
foreach($kostra as $silnice){
	imageline(
		$img ,
 		$silnice->from->getPos()->x * $MERITKO + $MERITKO, 
		$silnice->from->getPos()->y * $MERITKO + $MERITKO,
 		$silnice->to->getPos()->x * $MERITKO + $MERITKO, 
		$silnice->to->getPos()->y * $MERITKO + $MERITKO,
 		$roadColor 
	);
}


header( "Content-type: image/png" );
imagepng( $img );
imagedestroy( $img );

?>

