#include "common.h"

uint8_t strToDouble(char * pos, uint32_t len, double& returned){

	uint32_t i=0;
	uint8_t is_dot=0;
	double multiplier = 1;
	returned = 0;

	if(*pos=='-')i++;

	for(; i < len; i++){
		if(pos[i] == ' ');
		if(pos[i]<=0x20)break;
		else if(pos[i] == '.' || pos[i] == ','){
			if(is_dot)
				return 1;
			else
				is_dot = 1;
		}else if(!is_dot){
			if(pos[i] < '0' || pos[i] > '9')return 1;
			returned *= 10;
			returned += pos[i] - '0';
		}else{
			if(pos[i] < '0' || pos[i] > '9')return 1;
			multiplier /= 10;
			returned += multiplier*(pos[i]-'0');
		}
	}
	if(*pos=='-')returned*=-1;
	return 0;
}

uint8_t strToInt(char *pos, uint32_t len, int32_t& returned, uint32_t base){
	uint32_t i=0;
	returned=0;
	char temp;

	if(base>26*2+10)return 1;

	if(*pos=='-')i++;
	for(; i<len;++i){
		temp = pos[i];
		if(temp<=0x20)break;
		returned*=base;

		if(temp>=0 && temp<='9'){
			temp-='0';
			if(base<=temp)return 1;
			returned+=temp;
		}else if(temp>='A' && temp <= 'Z'){
			temp = temp-'A'+10;
			if(base<=temp)return 1;
			returned+=temp;
		}else if(temp>='a' && temp <= 'z'){
			temp = temp-'a'+36;
			if(base<=temp)return 1;
			returned+=temp;
		}else return 1;
	}
	if(*pos=='-')returned*=-1;
	return 0;
}

//http://stackoverflow.com/questions/3746274/line-intersection-with-aabb-rectangle
// a1 is line1 start, a2 is line1 end, b1 is line2 start, b2 is line2 end
inline bool Intersects(vec2 a1, vec2 a2, vec2 b1, vec2 b2, vec2& intersection){
    intersection = vec2(0);

    vec2 b = a2 - a1;
    vec2 d = b2 - b1;
    float bDotDPerp = b.getX() * d.getY() - b.getY() * d.getX();

    // if b dot d == 0, it means the lines are parallel so have infinite intersection points
    if (bDotDPerp == 0)
        return false;

    vec2 c = b1 - a1;
    float t = (c.getX() * d.getY() - c.getY() * d.getX()) / bDotDPerp;
    if (t < 0 || t > 1)
        return false;

    float u = (c.getX() * b.getY() - c.getY() * b.getX()) / bDotDPerp;
    if (u < 0 || u > 1)
        return false;

    intersection = a1 + b*t;

    return true;
}

float LineInRect(vec2 stL, vec2 endL, vec2 stR, vec2 endR){
	vec2 Inters[2];
	vec2 temp;
	float mem;
	uint32_t numIn=0;

	if(stR.getX()>endR.getX()){
		mem = stR.getX();
		stR.setX(endR.getX());
		endR.setX(mem);
	}
	if(stR.getY()>endR.getY()){
		mem = stR.getY();
		stR.setY(endR.getY());
		endR.setY(mem);
	}


	if(stL.getX()>stR.getX() && stL.getX()<endR.getX() && stL.getY()>stR.getY() && stL.getY()<endR.getY())Inters[numIn++]=stL;
	if(endL.getX()>stR.getX() && endL.getX()<endR.getX() && endL.getY()>stR.getY() && endL.getY()<endR.getY())Inters[numIn++]=endL;
	if(numIn==2)return (Inters[0]-Inters[1]).length();

	if(Intersects(stL, endL, vec2(stR.getX(), stR.getY()), vec2(stR.getX(), endR.getY()), temp)){
		if(numIn==0)Inters[numIn++]=temp;
		if(numIn==1 && Inters[0]!=temp)Inters[numIn++]=temp;
	}
	if(numIn==2)return (Inters[0]-Inters[1]).length();
	if(Intersects(stL, endL, vec2(stR.getX(), stR.getY()), vec2(endR.getX(), stR.getY()), temp)){
		if(numIn==0)Inters[numIn++]=temp;
		if(numIn==1 && Inters[0]!=temp)Inters[numIn++]=temp;
	}
	if(numIn==2)return (Inters[0]-Inters[1]).length();
	if(Intersects(stL, endL, vec2(stR.getX(), endR.getY()), vec2(endR.getX(), endR.getY()), temp)){
		if(numIn==0)Inters[numIn++]=temp;
		if(numIn==1 && Inters[0]!=temp)Inters[numIn++]=temp;
	}
	if(numIn==2)return (Inters[0]-Inters[1]).length();
	if(numIn==1 && Intersects(stL, endL, vec2(endR.getX(), stR.getY()), vec2(endR.getX(), endR.getY()), temp)){
		if(numIn==1 && Inters[0]!=temp)Inters[numIn++]=temp;
	}
	if(numIn==2)return (Inters[0]-Inters[1]).length();
	return 0;
}
