#include "common.h"
#include "world.h"

int main(int argc,char *argv[]){
	char *input;
	char *output;
	clock_t t;
	char *errMsg;

	uint8_t debug=0, quick=0, info=0;
	uint32_t i;
	uint8_t world_solving_result;

	if(argc>1)
		input = argv[1];
	else
		input = (char*)"input.txt";

	if(argc>2)
		output = argv[2];
	else
		output = (char*)"output.txt";

	if(argc>3){
		for(i=3;i<argc;++i){
			if(!strcmp(argv[i], "-debug"))
				debug = 1;
			else if(!strcmp(argv[i], "-quick"))
				quick = 1;
			else if(!strcmp(argv[i], "-info"))
				info = 1;
		}
	}

	World *world = new World();

	if(errMsg = world->setup(input)){
		fputs(errMsg, stderr);
		fputs("\n", stderr);
		return 1;
	}

	if(debug)t = clock();

	world_solving_result = world->solve(output, quick, info, debug);

	if(debug){
		printf("result of solving: %d\n", world_solving_result);
		printf("Time cost: %g\n", (float(clock()-t))/CLOCKS_PER_SEC);
	}

	return 0;
}
