#include "road.h"
#include "city.h"

Road::Road(uint32_t c1, uint32_t c2, uint32_t type):type(type){c[0]=c1; c[1]=c2;}
Road::Road(uint32_t c1, uint32_t c2, uint32_t type, float m, float t):type(type), money(m), time(t){c[0]=c1; c[1]=c2;}
Road::Road(Road *original){
	type = original->getType();
	money = original->getMoney();
	time = original->getTime();
	c[0] = original->getCN(0);
	c[1] = original->getCN(1);
	len = original->getLen();
}

void Road::computeTM(float m, float t, Vector<Region*>& regions, Vector<City*>& cities){
	uint32_t i;
	vec2 st=cities[c[0]]->getPos(); //start
	vec2 end=cities[c[1]]->getPos(); //end
	float len = (st-end).length();
	float temp;

	this->len = len;
	money = m*len;

	time=0;
	for(i=0;i<regions.size();++i){
		temp=LineInRect(st, end, regions[i]->getLU(), regions[i]->getRD());
		len-=temp;
		time+=t*temp*regions[i]->getDiff();
	}
	time += t*len;
}

bool Road::compare(Road *o){
	if(c[0]==o->getCN(0) && c[1]==o->getCN(1))return 1;
	if(c[0]==o->getCN(1) && c[1]==o->getCN(0))return 1;
	return 0;
}

uint32_t Road::getCN(uint32_t i){return c[i];}
